
--PUT_TILE()-------------------------------------------------------------------

global procedure put_tile(sequence xy, sequence pic)
    for i = 1 to length(pic) do
	poke(MAP+(xy[2]*20+i-1)*(length(TheMap[1])*16)+(xy[1])*16,pic[i])
    end for
end procedure

--ADD_BACK_SPRITES()-----------------------------------------------------------

global procedure add_back_sprites(sequence pic, sequence xy)
    for i = 1 to length(xy) do
	for y = 1 to length(pic) do
	    for x = 1 to length(pic[1]) do
		if pic[y][x] != 0 then
		    poke(MAP+(xy[i][2]+y-1)*(length(TheMap[1])*16)+(xy[i][1]+x),pic[y][x])
		end if
	    end for
	end for
    end for
end procedure

--MAKE_MAP()-------------------------------------------------------------------

global procedure make_map()
    for i = 1 to length(TheMap) do
	for j = 1 to length(TheMap[1]) do
	    put_tile({j-1,i-1},Levels[curlev][3][TheMap[i][j]])
	end for
    end for
end procedure

--MAKE_SCREEN()----------------------------------------------------------------

global procedure make_screen()
    atom x
    x=place[1]+12-143
    if x<0 or x > maplong-305 then
	x=oldx
    end if
    oldx=x
    for i = 1 to 200-HEIGHT-40 do
	mem_copy(VIDEO+(HEIGHT+i-1)*320+WIDTH,VIRTUAL+x+(i-1)*(length(TheMap[1])*16),
		 320-WIDTH*2)
    end for
end procedure

--MAKE_VIRTUAL()--------------------------------------------------------------

global procedure make_virtual()
    atom x
    x=place[1]+12-143
    if x<0 or x > maplong-305 then
	x=oldx
    end if
    oldx=x
    for i = 1 to 200-HEIGHT-40 do
	mem_copy(VIRTUAL+(i-1)*(length(TheMap[1])*16)+x,MAP+x+(i-1)*(length(TheMap[1])*16),
		 320)
    end for
end procedure    

--FINDBLOCK()------------------------------------------------------------------

global function findblock(atom x, atom y)
   sequence lok 
   lok={floor(x/16+1),floor(y/20+1)}
   return find(TheMap[lok[2]][lok[1]],blockers)
end function

--DIESANTA()-------------------------------------------------------------------

global procedure DieSanta(atom N)
    santamove=1
    if N then
	deadglit={1,place,actives[N][XY1]}
    end if
    DEAD=1        
end procedure

--TESTER()---------------------------------------------------------------------

global procedure tester(atom eye)
    if eye = 1 then
	if place[1] > (maplong-27) then
	    place[1]=maplong-27
	end if
	if findblock(place[1]-16+length(s1[1][1]),place[2]+39) then
	    place[1]=floor(place[1]/16)*16+7  
	end if
	return
    end if
    if eye = 2 then
	if place[1] < 0 then
	    place[1]=0
	end if
	if findblock(place[1],place[2]+39) then
	    place[1]=floor(place[1]/16+1)*16-2
	end if                               
	return
    end if
    if eye=3 then
	if place[2] < 0 then
	    place[2] = 0
	end if
    end if
    if eye=4 then
	if place[2]>120 then
	    DieSanta(0)
	    return
	end if
	if dr=RIGHT then   
	   if findblock(place[1]+10,place[2]+39) or
		findblock(place[1]+15,place[2]+39) or
		findblock(place[1]+24,place[2]+39) then
		Fall=0
		safe=1
		Height=LOW
		place[2]=floor(place[2]/20+1)*20-20
	   end if
	else
	   if findblock(place[1]+2,place[2]+39) or
		findblock(place[1]+8,place[2]+39) or
		findblock(place[1]+16,place[2]+39) then
		Fall=0
		safe=1
		Height=LOW
		place[2]=floor(place[2]/20+1)*20-20
	   end if
	end if
    end if
    if eye=5 then
	if dr=RIGHT then
	    if findblock(place[1]+10,place[2]+40) or
	    findblock(place[1]+15,place[2]+40) or
	    findblock(place[1]+24,place[2]+40) then
		return
	    else
		Fall=1
		safe=0
		wasover=JSpeed
		frame=faller
	    end if
	else
	    if findblock(place[1],place[2]+40)
	    or findblock(place[1]+8,place[2]+40)
	    or findblock(place[1]+16,place[2]+40) then
		return
	    else    
		Fall=1
		safe=0
		wasover=JSpeed
		frame=faller
	    end if
	end if
    end if
end procedure

--DOJUMP()---------------------------------------------------------------------

global procedure DoJump()
    atom dist, height
    dist=0
    height=0
    if air < 1 then
	Jump=0
	Fall=1
	frame=faller
	return
    end if
    dist=wasover+bonus+jumpover
    jumpover=0
    if air<25 then
	if jump=1 then
	    height=JSpeed*2
	else
	    Jump=0
	    Fall=1
	    if Height=LOW then
		frame=faller
	    end if
	    return
	end if
    else
	height=JSpeed*2
    end if
    jump=0
    if Height=LOW then
	if air<30 then
	    if bonus > 0 then
		Height=HIGH
		frame=flip
	    end if
	end if
    end if
    air=air-height
    if dr=RIGHT then
	place[1]=place[1]+dist
	tester(1)
	place[2]=place[2]-height
	tester(3)
    else
	place[1]=place[1]-dist
	tester(2)
	place[2]=place[2]-height
	tester(3)
    end if
end procedure

--DOFALL()---------------------------------------------------------------------

global procedure DoFall()
    atom dist
    dist=0
    if Height=HIGH then
	if air>35 then
	    frame=faller
	    Height=LOW
	end if
    end if
    dist=wasover+jumpover+bonus
    jumpover=0
    air=air+2
    if dr=RIGHT then
	place[1]=place[1]+dist
	tester(1)
	place[2]=place[2]+JSpeed*2
	tester(4)
     else
	place[1]=place[1]-dist
	tester(2)
	place[2]=place[2]+JSpeed*2
	tester(4)
     end if
end procedure

--DRAW_SPRITE()----------------------------------------------------------------

global procedure draw_sprite(sequence thepic, sequence loc)
	for y = 1 to length(thepic) do
	    for x = 1 to length(thepic[1]) do
		if thepic[y][x] != 144 then
		    poke(VIRTUAL+(loc[2]+y-1)*
			(length(TheMap[1])*16)+(loc[1]+x),thepic[y][x])
		end if
	    end for
	 end for
end procedure
     
--CONNECT()--------------------------------------------------------------------

global function connect(sequence loc)
    if dr=RIGHT then
	if loc[1] > place[1]+10 and loc[1] < place[1]+22 then
	    if loc[2] > place[2]+10 and loc[2] < place[2]+41 then
		return 1
	    end if
	end if
    else
	if loc[1] > place[1]+2 and loc[1] < place[1]+15 then
	    if loc[2] > place[2]+10 and loc[2] < place[2]+41 then
		return 1
	    end if
	end if
    end if
    return 0
end function

--CHECK_CONTACT()--------------------------------------------------------------

global function check_contact(sequence xy, sequence xy2)
    if connect(xy) then
	return 1
    elsif connect(xy2) then
	return 1
    elsif connect({xy[1],xy2[2]}) then
	return 1
    elsif connect({xy2[1],xy[2]}) then
	return 1
    elsif connect({xy[1]+(xy2[1]-xy[1])/2,xy[2]}) then
	return 1
    else
	return 0
    end if
end function

--DRAW_SANTA()-----------------------------------------------------------------

global procedure draw_santa(sequence pic)
    atom a,b
    sequence xtra
    if length(pic)>30 then
	for y = 1 to length(pic) do
	    for x = 1 to length(pic[1]) do
		if pic[y][x] != 144 then
		    poke(VIRTUAL+(place[2]+y-1)*
			(length(TheMap[1])*16)+(place[1]+x),pic[y][x])
		end if
	    end for
	 end for
    else
	for y = 1 to length(pic) do
	    for x = 1 to length(pic[1]) do
		if pic[y][x] != 144 then
		    poke(VIRTUAL+(place[2]+y-1+8)*
			(length(TheMap[1])*16)+(place[1]+x-8),pic[y][x])
		end if
	    end for
	 end for
    end if
    if spark then
	sanim=sanim+ASpeed
	if sanim >= 5 then
	    sanim=1
	end if
	xtra=sparkle[floor(sanim)]
	b=place[2]+(30-length(xtra))/2+5
	a=(place[1]-2)+(30-length(xtra))/2
	draw_sprite(xtra,{a,b})
	spark=spark-1
    end if
end procedure
